// matriz.h
// Clases de matrices

#ifndef _MATRIZ_
#define _MATRIZ_

#include <iostream>
#include <vector.h>

// Class RMatriz
/// Define una clase de matrices reales
/*
 *\ingroup P4
 */
class RMatriz {
 private:
/// arreglo dinmico de elementos
  double* pElem;         
/// nmero de filas 
  int pFilas;
  /// nmero de columnas            
  int pCols; 

 public:
  /// Constructor estndar (no hay constructor por defecto)
  RMatriz(int nfilas, int ncols);
  /// Constructor de copia
  RMatriz(const RMatriz& m);
  /// Destructor
  ~RMatriz();

  // Funciones de acceso
/// devuelve el nmero de filas
  const int& filas() const;      
/// devuelve el nmero de columnas
  const int& columnas() const;   

  // Operadores
  /// lectura (ejemplo, cout << a(i,j)) i = 1,2...n
  const double& operator () (int fila, int col) const;
  /// asignacin (ejemplo,  a(i,j) = 7.)
  double& operator () (int fila, int col);
  
  /// asigna una matriz a otra
  RMatriz& operator = (const RMatriz& m);
  /// m1+=m2
  RMatriz& operator += (const RMatriz& m);
  /// m1-=m2
  RMatriz& operator -= (const RMatriz& m);
  /// m1*=d
  RMatriz& operator *= (double a);
//Declaro las funciones internas a la clase;funciones intercambiaFilas y intercambiaColunas!!!
RMatriz& intercambiaFilas(int i,int j);
RMatriz& intercambiaColumnas(int i,int j);


};


/* Operaciones con matrices */
/// -m
RMatriz operator - (const RMatriz& m);
/// m1 + m2
RMatriz operator + (const RMatriz& m1, const RMatriz& m2);
/// m1 -m2
RMatriz operator - (const RMatriz& m1, const RMatriz& m2);
/// m1 *m2
RMatriz operator * (const RMatriz& m1, const RMatriz& m2);
/// m1 *d
RMatriz operator * (const RMatriz& v1, double d);
/// d*m1
RMatriz operator * (double d, const RMatriz& v1);
/// traspuesta
RMatriz traspuesta(const RMatriz& m);
//Declaro las funciones externas a la clase,funciones Traza,proyectaFila y proyectaColumna!!!
int Traza(const RMatriz& m);
RVector proyectaFila(const RMatriz& m,int fila);
RVector proyectaColumna(const RMatriz& m,int col);
/// escribe una matriz
ostream& operator << (ostream& s, const RMatriz& m);


#endif   /* _MATRIZ_ */
