// vector.h
// Clases de vectores
//Modificado por Marc Belda
#ifndef _VECTOR___
#define _VECTOR___

#include <iostream>

// Clase RVector
/// Define un vector de nmeros reales (tipo double)
/*
 *\ingroup P4
 */
class RVector {
 private:
  /// arreglo dinmico de elementos
    double* pElem;   
    // dimensin del vector 
    int pDim; 

 public:
    /// Constructor estndar (no permite constructor por defecto)
    RVector(int dimension);
    /// Constructor de copia
    RVector(const RVector& v);
    /// Destructor
    ~RVector();

    // Funciones de acceso
    /// devuelve la dimensin del vector
    const int& dimension() const;  
    // no permite asignar la dimensin del vector excepto en constructor

    // Operadores
    /// permite leer un elemento del vector v(i) (i=1,2,...n)
    const double& operator () (int indice) const;
    /// permite asignar un elemento del vector v(i) (i=1,2,...n)
    double& operator () (int indice);
  
    /// asigna un vector a otro
    RVector& operator = (const RVector& v);
    /// v1+=v2 --> v1 = v1 + v2
    RVector& operator += (const RVector& v);
    /// v1-=v2 --> v1 = v1 - v2
    RVector& operator -= (const RVector& v);
    /// v1*=d --> v1 = v1* d
    RVector& operator *= (double a);
//Aado la declaricion de la funcion interna;funcion intercambia!!!
RVector& intercambia (int i,int j);
};

// Operaciones con vectores
/// -v
RVector operator - (const RVector& v);
/// v1+v2
RVector operator + (const RVector& v1, const RVector& v2);
/// v1-v2
RVector operator - (const RVector& v1, const RVector& v2);
/// producto escalar
double  operator * (const RVector& v1, const RVector& v2);
/// v1*d, d es un escalar
RVector operator * (const RVector& v1, double d);
/// d*v1, d es un escalar
RVector operator * (double d, const RVector& v1);
/// producto escalar
double productoEscalar(const RVector& v1, const RVector& v2);
//Aado la declaracion de las funciones externas,funcion norma,maximo y minimo!!!
double norma(const RVector& v1);
int maximo(const RVector& v1,double& max);
int minimo(const RVector& v1,double& min);
/// escribe la clase
ostream& operator << (ostream& s, const RVector& v);

#endif   /* _VECTOR___ */
